<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="区划名称" prop="regionName">
        <el-input
          v-model="queryParams.regionName"
          placeholder="请输入区划名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="区划编码" prop="regionCode">
        <el-input
          v-model="queryParams.regionCode"
          placeholder="请输入区划编码"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="行政等级" prop="regionLevel">
        <el-input
          v-model="queryParams.regionLevel"
          placeholder="请输入行政等级"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="父id" prop="parentRegionId">
        <el-input
          v-model="queryParams.parentRegionId"
          placeholder="请输入父id"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="未知字段" prop="attribute1">
        <el-input
          v-model="queryParams.attribute1"
          placeholder="请输入未知字段"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
	    <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['sfa:regions:add']"
        >新增</el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table
      v-loading="loading"
      :data="regionsList"
      row-key="regionId"
      default-expand-all
      :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
    >
      <el-table-column label="区划名称" prop="regionName" />
      <el-table-column label="区划编码" align="center" prop="regionCode" />
      <el-table-column label="行政等级" align="center" prop="regionLevel" />
      <el-table-column label="父id" align="center" prop="parentRegionId" />
      <el-table-column label="未知字段" align="center" prop="attribute1" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['sfa:regions:edit']"
          >修改</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-plus"
            @click="handleAdd(scope.row)"
            v-hasPermi="['sfa:regions:add']"
          >新增</el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['sfa:regions:remove']"
            class="text-danger"
          >删除</el-button>
        </template>
      </el-table-column>
    </el-table>

    <!-- 添加或修改行政区划对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="区划名称" prop="regionName">
          <el-input v-model="form.regionName" placeholder="请输入区划名称" />
        </el-form-item>
        <el-form-item label="区划编码" prop="regionCode">
          <el-input v-model="form.regionCode" placeholder="请输入区划编码" />
        </el-form-item>
        <el-form-item label="行政等级" prop="regionLevel">
          <el-input v-model="form.regionLevel" placeholder="请输入行政等级" />
        </el-form-item>
        <el-form-item label="父id" prop="parentRegionId">
          <treeselect v-model="form.parentRegionId" :options="regionsOptions" :normalizer="normalizer" placeholder="请选择父id" />
        </el-form-item>
        <el-form-item label="未知字段" prop="attribute1">
          <el-input v-model="form.attribute1" placeholder="请输入未知字段" />
        </el-form-item>
        <el-form-item label="删除标记" prop="delFlag">
          <el-input v-model="form.delFlag" placeholder="请输入删除标记" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import { listRegions, getRegions, delRegions, addRegions, updateRegions } from "@/api/sfa/regions";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";

export default {
  name: "Regions",
  components: {
    Treeselect
  },
  data() {
    return {
      // 遮罩层
      loading: true,
      // 显示搜索条件
      showSearch: true,
      // 行政区划表格数据
      regionsList: [],
      // 行政区划树选项
      regionsOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        regionName: null,
        regionCode: null,
        regionLevel: null,
        parentRegionId: null,
        attribute1: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
      }
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询行政区划列表 */
    getList() {
      this.loading = true;
      listRegions(this.queryParams).then(response => {
        this.regionsList = this.handleTree(response.data, "regionId", "parentRegionId");
        this.loading = false;
      });
    },
    /** 转换行政区划数据结构 */
    normalizer(node) {
      if (node.children && !node.children.length) {
        delete node.children;
      }
      return {
        id: node.regionId,
        label: node.regionName,
        children: node.children
      };
    },
	/** 查询行政区划下拉树结构 */
    getTreeselect() {
      listRegions().then(response => {
        this.regionsOptions = [];
        const data = { regionId: 0, regionName: '顶级节点', children: [] };
        data.children = this.handleTree(response.data, "regionId", "parentRegionId");
        this.regionsOptions.push(data);
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        regionId: null,
        regionName: null,
        regionCode: null,
        regionLevel: null,
        parentRegionId: null,
        attribute1: null,
        delFlag: null,
        createTime: null,
        createBy: null,
        updateTime: null,
        updateBy: null
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd(row) {
      this.reset();
      this.getTreeselect();
      if (row != null && row.regionId) {
        this.form.parentRegionId = row.regionId;
      } else {
        this.form.parentRegionId = 0;
      }
      this.open = true;
      this.title = "添加行政区划";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      this.getTreeselect();
      if (row != null) {
        this.form.parentRegionId = row.regionId;
      }
      getRegions(row.regionId).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改行政区划";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.regionId != null) {
            updateRegions(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addRegions(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      this.$modal.confirm('是否确认删除行政区划编号为"' + row.regionId + '"的数据项？').then(function() {
        return delRegions(row.regionId);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {});
    }
  }
};
</script>
